package com.lovecoding.aop;

import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * 代理对象， 它代替我们去执行业务代码
 * 代替我们去 调用加减法
 * 静态代理
 * 因为代理对象是 编写到代码中的， 不是运行时创建的， 所以叫静态代理
 * 还有动态代理  动态代理是不需要固定代理对象的
 * 用的技术就是 反射
 */
@Component
public class CounterAop implements Counter {

    @Resource(name = "countterImpl")
    private Counter counter;

    @Override
    public int add(int a, int b) {
        System.out.println( "[日志]加法参数：" + a + " 参数：" + b );
        int n = counter.add(a, b);
        System.out.println( "[日志]加法计算结构：" + n );
        return n;
    }

    @Override
    public int sub(int a, int b) {
        System.out.println( "[日志]减法参数：" + a + " 参数：" + b );
        int n = counter.sub(a, b);
        System.out.println( "[日志]减法计算结构：" + n );
        return n;
    }
}
