package com.lovecoding.jdbc.dao;

import com.lovecoding.jdbc.anno.Logs;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

@Repository
public class BookImpl implements Book {

    @Autowired
    JdbcTemplate jdbcTemplate;

    /**
     * 查询书的价格
     * @param bookid
     * @return
     */
    @Override
    //@Logs
    public int getBook(int bookid) {
        Object [] id = {bookid};
        Integer integer = jdbcTemplate.queryForObject(
                "SELECT price FROM t_book WHERE book_id = ?",
                id,
                Integer.class
        );
        return integer;
    }

    /**
     * 扣减书的库存
     * @param bookid
     */
    @Override
    public void subBook(int bookid) {
        int update = jdbcTemplate.update(
                "UPDATE t_book set stock = stock - 1 WHERE book_id = ?",
                bookid
        );
    }
}
